#include "stdafx.h"

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
//
//
//
//
//

#define absVal(a) (((a) > 0) ? (a) : (-a))

//
//
//
//
//

__declspec(dllexport) double __stdcall iAutoCorrMax(const double *X, int period, int maxLag, int i, int bars)
{
	double avgi     = X[i]; for (int k=1; k<period && (i-k)>=0; k++) avgi     += (X[i-k]);                    avgi     /= (double)period;
    double variance = 0;    for (int k=0; k<period && (i-k)>=0; k++) variance += (X[i-k]-avgi)*(X[i-k]-avgi); variance /= (double)period;
   
    //
    //
    //
    //
    //
               
	double corr = 0;
		if (variance != 0 && i>=(period+maxLag))
		{
			double max  = 0;
			double avgd = avgi+(X[i-period]-X[i])/(double)period;
			for (int k=1; k<=maxLag; k++)
			{
				double covariance = 0; for (int j=0; j<period && (i-j-k)>=0; j++) covariance += (X[i-j]-avgi)*(X[i-j-k]-avgd);
				double current    = (covariance/period)/variance;
                     if (absVal(current)>max)
                     {
                        corr = current; max = absVal(current);
                     }
				avgd += (X[i-k-period]-X[i-k])/(double)period;
			}
		}

	//
	//
	//
	//
	//

	return(corr);
}